-- ========================================================================== --
-- 										 EskaQuestTracker                                       --
-- @Author   : Skamer <https://mods.curse.com/members/DevSkamer>              --
-- @Website  : https://wow.curseforge.com/projects/eska-quest-tracker         --
-- ========================================================================== --
Scorpio                "EskaQuestTracker.Classes.Quest"                  "1.0.0"
-- ========================================================================== --
namespace "EQT"
-- ========================================================================== --
class "Quest" extend "IReusable" "IFrame" "IObjectiveHolder"
  -- ======================================================================== --
  -- Handlers
  -- ======================================================================== --
  local function SetName(self, new, old, prop)
    self.frame.header.text:SetText(new)
  end
  -- ======================================================================== --
  -- Methods
  -- ======================================================================== --
  __Arguments__{}
  function GetQuestItem(self)
    if not self.questItem then
      self.questItem = _ObjectManager:GetQuestItem()
      self.questItem:SetParent(self.frame)
      -- self:Show()
    end

    return self.questItem
  end

  __Arguments__{}
  function Draw(self)
    if self.questItem then
      local obj = self.objectives[1]
      if obj then
        -- questItem
        -- self.questItem:ClearAllPoints()
        self.questItem:Show()
        self.questItem.frame:SetPoint("TOPLEFT", self.frame.header.frame, "BOTTOMLEFT", 5, -5)
        --self.questItem:SetParent(self.frame)

        -- objective
        obj.frame:SetPoint("TOPLEFT", self.questItem.frame, "TOPRIGHT")
        obj.frame:SetPoint("TOPRIGHT", self.frame.header.frame, "BOTTOMRIGHT")

        self:DrawObjectives(self.frame.header.frame, true)
        if self.height < self.questItem.height + self.baseHeight + 10 then
          self.height = self.baseHeight + self.questItem.height + 10
        end
      end
    else
        self:DrawObjectives(self.frame.header.frame)
    end

  end

  function Reset(self)
    --for _, objective in self.objectives:GetIterator() do
      --objective.isReusable = true
    --end

    self:ClearAllPoints()
    self:SetParent(nil)
    self:Hide()

    -- Reset Properties
    --self.id = Reflector.GetDefaultValue(self, "id")
    --self.name = Reflector.GetDefaultValue(self, "name")
    --self.level = Reflector.GetDefaultValue(self, "level")
    --self.header = Reflector.GetDefaultValue(self, "header")
    --self.distance = Reflector.GetDefaultValue(self, "distance")
    --self.isBounty = Reflector.GetDefaultValue(self, "isBounty")
    --self.isTask = Reflector.GetDefaultValue(self, "isTask")
    --self.isHidden = Reflector.GetDefaultValue(self, "isHidden")
    --self.isOnMap = Reflector.GetDefaultValue(self, "isOnMap")

    -- Reset properties 
    self.id = nil
    self.name = nil
    self.level = nil
    self.header = nil
    self.distance = nil
    self.isBounty = nil
    self.isTask = nil
    self.isHidden = nil
    self.isOnMap = nil



    --self.questItem = Reflector.GetDefaultValue(self, "questItem")
    if self.questItem then
      self.questItem.isReusable = true
      self.questItem = nil
    end
    -- Reset variables
    --self.objectives =  ObjectArray(Objective)

  end
  -- ======================================================================== --
  -- Properties
  -- ======================================================================== --
  property "id" { TYPE= Number, DEFAULT = -1 }
  property "name" { TYPE = String, HANDLER = SetName}
  property "level" { TYPE = Number, DEFAULT = 0}
  property "header" { TYPE = String, DEFAULT = "Misc"}
  property "distance" { TYPE = Number, DEFAULT = -1}
  property "isBounty" { TYPE = Boolean, DEFAULT = false }
  property "isTask" { TYPE = Boolean, DEFAULT = false }
  property "isHidden" { TYPE = Boolean, DEFAULT = false }
  property "isOnMap" { TYPE = Boolean, DEFAULT = false }
  --property "questItem" { TYPE = Class, DEFAULT = nil, GET = "GetQuestItem", SET = "SetQuestItem" }
  -- ======================================================================== --
  -- Constructors
  -- ======================================================================== --
  function Quest(self)
    local frame = CreateFrame("Frame")
    frame:SetBackdrop(_Backdrops.Common)
    frame:SetBackdropColor(0, 0, 0, 0.3) -- 0.2
    frame:SetBackdropBorderColor(0, 0, 0, 0)

    local headerFrame = CreateFrame("Button", nil, frame)
    headerFrame:SetBackdrop(_Backdrops.Common)
    headerFrame:SetBackdropColor(0, 0, 0, 0.4)
    headerFrame:SetBackdropBorderColor(0, 0, 0)
    headerFrame:SetPoint("TOPRIGHT")
    headerFrame:SetPoint("TOPLEFT")
    headerFrame:SetHeight(14)

    -- script
    headerFrame:SetScript("OnEnter", function()
      headerFrame:SetBackdropColor(0, 148/255, 1, 0.4)
    end)

    headerFrame:SetScript("OnLeave", function()
      headerFrame:SetBackdropColor(0, 0, 0, 0.4)
    end)

    headerFrame:SetScript("OnClick", function()
      QuestLogPopupDetailFrame_Show(GetQuestLogIndexByID(self.id))
    end)

    local headerText = headerFrame:CreateFontString(nil, "OVERLAY", "GameFontHighlightSmall")
    headerText:SetFont(_Addon.Fonts.Title, 7, nil) -- 10
    headerText:GetFontObject():SetShadowOffset(0.5, 0)
    headerText:GetFontObject():SetShadowColor(0, 0, 0, 0.4)
    headerText:SetTextColor(1.0, 191/255, 0)
    headerText:SetAllPoints()
    headerText:SetText("No quest title")

    local headerLevel = headerFrame:CreateFontString(nil, "OVERLAY", "GameFontHighlightSmall")
    headerLevel:SetFont(_Addon.Fonts.Title, 7, nil)
    headerLevel:GetFontObject():SetShadowOffset(0.5, 0)
    headerLevel:GetFontObject():SetShadowColor(0, 0, 0, 0.4)
    headerLevel:SetTextColor(1.0, 191/255, 0)
    headerLevel:SetPoint("RIGHT", -2)
    headerLevel:SetText("110")

    frame.header = {
      frame = headerFrame,
      text = headerText
    }

    self.frame = frame
    self.height = 14
    self.baseHeight = self.height

    --self.objectives = ObjectArray(Objective)

  end

endclass "Quest"
